Package jaxe

# Interface InterfaceSchema

All Known Implementing Classes:
  `SchemaRelaxNG`, `SchemaSimple`, `SchemaW3C`

public interface InterfaceSchema
Interface pour un langage de schéma, comme celui du W3C, Relax NG, ou les schémas simples de Jaxe. Utilise la notion de "référence d'élément" qui correspond à l'élément du schéma qui définit l'élément XML (cela suppose que les schémas sont eux-mêmes des arbres XML).

## Method Summary

Modifier and Type
Method
Description
`boolean`
`aEspace(String espace)`
Renvoie true si l'espace de nom est défini dans le schéma
`boolean`
`attributObligatoire(Element refParent, Element refAttribut)`
Renvoit true si l'attribut est obligatoire sous le parent.
`boolean`
`attributValide(Element refAttribut, String valeur)`
Renvoie true si la valeur donnée est une valeur valide pour l'attribut
`boolean`
`contientDuTexte(Element refElement)`
Renvoie true si l'élément dont on donne la référence peut contenir du texte
`String`
`documentationAttribut(Element refAttribut)`
Renvoie la documentation d'un attribut à partir de sa référence
`String`
`documentationElement(Element refElement)`
Renvoie la documentation d'un élément dont on donne la référence (sous forme de texte simple, avec des \n pour faire des sauts de lignes)
`boolean`
`elementDansSchema(Element refElement)`
Renvoie true si la référence vient de ce schéma
`boolean`
`elementObligatoire(Element refParent, Element refEnfant)`
Renvoit true si l'enfant est obligatoire sous le parent.
`boolean`
`enfantsMultiples(Element refParent, Element refEnfant)`
Renvoit true si le parent peut avoir des enfants multiples avec la référence refEnfant.
`String`
`espaceAttribut(String nomAttribut)`
Renvoie l'espace de noms d'un attribut à partir de son nom complet (avec le préfixe s'il y en a un)
`String`
`espaceAttribut(Element refAttribut)`
Renvoie l'espace de noms d'un attribut à partir de sa référence, ou null si aucun n'est défini
`String`
`espaceCible()`
Renvoie l'espace de noms cible du schéma (attribut targetNamespace avec WXS).
`String`
`espaceElement(Element refElement)`
Renvoie l'espace de nom de l'élément dont la référence est passée en paramètre, ou null si l'espace de noms n'est pas défini.
`boolean`
`estObligatoire(Element refAttribut)`
Deprecated.
`String`
`expressionReguliere(Element refParent, boolean modevisu, boolean modevalid)`
Expression régulière correspondant au schéma pour un élément parent donné
`ArrayList<Element>`
`listeAttributs(Element refElement)`
Renvoie la liste des références des attributs possibles pour un élément dont on donne la référence en paramètre
`ArrayList<Element>`
`listeElementsDansEspaces(Set<String> espaces)`
Renvoie les références des éléments qui sont dans les espaces de noms passés en paramètre
`ArrayList<Element>`
`listeElementsHorsEspace(String espace)`
Renvoie les références des éléments qui ne sont pas dans l'espace de noms passé en paramètre
`ArrayList<Element>`
`listeElementsParents(Element refElement)`
Renvoie la liste des références des parents possibles pour un élément dont la référence est passée en paramètre
`ArrayList<String>`
`listeEspaces()`
Renvoie la liste des espaces de noms (String) utilisés par ce schéma.
`ArrayList<Element>`
`listeSousElements(Element refParent)`
Renvoie les références des éléments enfants de l'élément dont la référence est passée en paramètre
`ArrayList<Element>`
`listeTousElements()`
Renvoie les références de tous les éléments du schéma
`ArrayList<String>`
`listeValeursAttribut(Element refAttribut)`
Renvoie la liste des valeurs possibles pour un attribut, à partir de sa référence.
`ArrayList<String>`
`listeValeursElement(Element refElement)`
Renvoie la liste des valeurs possibles pour un élément, à partir de sa référence.
`String`
`nomAttribut(Element refAttribut)`
Renvoie le nom d'un attribut à partir de sa référence
`String`
`nomElement(Element refElement)`
Renvoie le nom de l'élément dont la référence est donnée.
`Element`
`parentAttribut(Element refAttribut)`
Renvoie la référence du premier élément parent d'un attribut à partir de sa référence
`String`
`prefixeElement(Element refElement)`
Renvoie le préfixe à utiliser pour créer un élément dont on donne la référence, ou null s'il n'y en a pas.
`String`
`prefixeEspace(String ns)`
Renvoie un préfixe à utiliser pour l'espace de noms donné, ou null si aucune suggestion n'est possible
`Element`
`referenceElement(String nom)`
Renvoie la référence du premier élément du schéma avec le nom donné.
`Element`
`referenceElement(Element el)`
Renvoie la référence du premier élément du schéma avec le nom et l'espace de noms de l'élément passé en paramètre.
`Element`
`referenceElement(Element el, Element refParent)`
Renvoie la référence du premier élément du schéma avec le nom et l'espace de noms de l'élément passé en paramètre, et avec le parent dont la référence est passée en paramètre.
`boolean`
`valeurElementValide(Element refElement, String valeur)`
Renvoie true si la valeur donnée est une valeur valide pour l'élément
`String`
`valeurParDefaut(Element refAttribut)`
Renvoie la valeur par défaut d'un attribut dont la référence est donnée en paramètre

## Method Details

### elementDansSchema

boolean elementDansSchema(Element refElement)
Renvoie true si la référence vient de ce schéma

### referenceElement

Element referenceElement(String nom)
Renvoie la référence du premier élément du schéma avec le nom donné.

### referenceElement

Element referenceElement(Element el)
Renvoie la référence du premier élément du schéma avec le nom et l'espace de noms de l'élément passé en paramètre.

### referenceElement

Element referenceElement(Element el, Element refParent)
Renvoie la référence du premier élément du schéma avec le nom et l'espace de noms de l'élément passé en paramètre, et avec le parent dont la référence est passée en paramètre.

### nomElement

String nomElement(Element refElement)
Renvoie le nom de l'élément dont la référence est donnée.

### espaceElement

String espaceElement(Element refElement)
Renvoie l'espace de nom de l'élément dont la référence est passée en paramètre, ou null si l'espace de noms n'est pas défini.

### prefixeElement

String prefixeElement(Element refElement)
Renvoie le préfixe à utiliser pour créer un élément dont on donne la référence, ou null s'il n'y en a pas.

### documentationElement

String documentationElement(Element refElement)
Renvoie la documentation d'un élément dont on donne la référence (sous forme de texte simple, avec des \n pour faire des sauts de lignes)

### listeValeursElement

ArrayList<String> listeValeursElement(Element refElement)
Renvoie la liste des valeurs possibles pour un élément, à partir de sa référence. Renvoie null s'il y a un nombre infini de valeurs possibles ou si l'élément n'a pas un type simple.

### valeurElementValide

boolean valeurElementValide(Element refElement, String valeur)
Renvoie true si la valeur donnée est une valeur valide pour l'élément

### listeEspaces

ArrayList<String> listeEspaces()
Renvoie la liste des espaces de noms (String) utilisés par ce schéma.

### aEspace

boolean aEspace(String espace)
Renvoie true si l'espace de nom est défini dans le schéma

### prefixeEspace

String prefixeEspace(String ns)
Renvoie un préfixe à utiliser pour l'espace de noms donné, ou null si aucune suggestion n'est possible

### espaceCible

String espaceCible()
Renvoie l'espace de noms cible du schéma (attribut targetNamespace avec WXS). Attention: Le concept d'un espace cible unique pour un schéma n'existe pas avec Relax NG.

### listeElementsHorsEspace

ArrayList<Element> listeElementsHorsEspace(String espace)
Renvoie les références des éléments qui ne sont pas dans l'espace de noms passé en paramètre

### listeElementsDansEspaces

ArrayList<Element> listeElementsDansEspaces(Set<String> espaces)
Renvoie les références des éléments qui sont dans les espaces de noms passés en paramètre

### listeTousElements

ArrayList<Element> listeTousElements()
Renvoie les références de tous les éléments du schéma

### elementObligatoire

boolean elementObligatoire(Element refParent, Element refEnfant)
Renvoit true si l'enfant est obligatoire sous le parent.

### enfantsMultiples

boolean enfantsMultiples(Element refParent, Element refEnfant)
Renvoit true si le parent peut avoir des enfants multiples avec la référence refEnfant.

### listeSousElements

ArrayList<Element> listeSousElements(Element refParent)
Renvoie les références des éléments enfants de l'élément dont la référence est passée en paramètre

### expressionReguliere

String expressionReguliere(Element refParent, boolean modevisu, boolean modevalid)
Expression régulière correspondant au schéma pour un élément parent donné

Parameters:
  `modevisu` - True si on cherche une expression régulière à afficher pour l'utilisateur
  `modevalid` - Pour obtenir une validation stricte au lieu de chercher si une insertion est possible

### listeElementsParents

ArrayList<Element> listeElementsParents(Element refElement)
Renvoie la liste des références des parents possibles pour un élément dont la référence est passée en paramètre

### listeAttributs

ArrayList<Element> listeAttributs(Element refElement)
Renvoie la liste des références des attributs possibles pour un élément dont on donne la référence en paramètre

### nomAttribut

String nomAttribut(Element refAttribut)
Renvoie le nom d'un attribut à partir de sa référence

### espaceAttribut

String espaceAttribut(Element refAttribut)
Renvoie l'espace de noms d'un attribut à partir de sa référence, ou null si aucun n'est défini

### documentationAttribut

String documentationAttribut(Element refAttribut)
Renvoie la documentation d'un attribut à partir de sa référence

### espaceAttribut

String espaceAttribut(String nomAttribut)
Renvoie l'espace de noms d'un attribut à partir de son nom complet (avec le préfixe s'il y en a un)

### estObligatoire

@Deprecated boolean estObligatoire(Element refAttribut)
Deprecated.
Renvoie true si un attribut est obligatoire, à partir de sa définition. Attention: ce n'est pas possible à déterminer avec seulement la référence d'attribut avec Relax NG. Il vaut mieux utiliser attributObligatoire.

### attributObligatoire

boolean attributObligatoire(Element refParent, Element refAttribut)
Renvoit true si l'attribut est obligatoire sous le parent.

### listeValeursAttribut

ArrayList<String> listeValeursAttribut(Element refAttribut)
Renvoie la liste des valeurs possibles pour un attribut, à partir de sa référence. Renvoie null s'il y a un nombre infini de valeurs possibles.

### valeurParDefaut

String valeurParDefaut(Element refAttribut)
Renvoie la valeur par défaut d'un attribut dont la référence est donnée en paramètre

### attributValide

boolean attributValide(Element refAttribut, String valeur)
Renvoie true si la valeur donnée est une valeur valide pour l'attribut

### parentAttribut

Element parentAttribut(Element refAttribut)
Renvoie la référence du premier élément parent d'un attribut à partir de sa référence

### contientDuTexte

boolean contientDuTexte(Element refElement)
Renvoie true si l'élément dont on donne la référence peut contenir du texte